/*
Copyright 2012 Arun Kumar and Christopher Re

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

This work was supported by the Microsoft Jim Gray Systems Lab, 
the National Science Foundation and the Office of Naval Research.
*/
#ifndef STACPUTIL_H
#define STACPUTIL_H

#include <iostream>
#include <cmath>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include "staccatoSQLUtils.h"
#include <cstring>
using namespace std;

void dynmatrdfs (map <int, vector <int> > *revgph, vector<double>* blkreachprobs, double* probmatrs, double* scratches, int* memo, int NUMST, int curnode, map<int,int>* newblkno);
void dynmatrdfsinter (map <int, vector <int> > *revgph, vector<double>* blkreachprobs, double* probmatrs, double* scratches, int* memo, int NUMST, int curnode, map<int,int>* newblkno, map<int, double> *intersblkprob);

void getprojn(structureInfo* stacinfo, map<int, vector<int> > *stacgraphrev, map<int, vector<int> > *stacgraphproj, set <int> *endblks, int remlen, int curblk);

void dfsgetreach(map<int, vector<int> > *gph, int curblk, int* reachable);
void dfstillend(map<int, vector<int> > *stacgraph, map<int, vector<int> > *stacgraphproj, int* allcdone, int curblk);

void dfsgetSBi(structureInfo* stacinfo, int *curtops, int *memor, set <int> *SBi, int curblk, int limitblk, int sign);

double dyndisjreachprob(map<int, vector<int> > *revgph, structureInfo* stacinfo, int curblk, set<int> *MStops, int* memodynflag, double* memodynprob);
void getMinSet(structureInfo stacinfo, set<int> extblks, set<int> *MSexttops, int flag);
void getInterProb(structureInfo stacinfo, map <int, vector <int> > stacgraphrev, set<int> sblks, set<int> MStops, map<int, double> *intersblkprob);

int getProjection (int theargsL, structureInfo stacinfo, vector < pair <int, pair <int, int> > > titersecond, map<int, vector<int> > *stacgraphproj, map<int, double> *intersblkprob);

#endif
