/*
Copyright 2012 Arun Kumar and Christopher Re

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

This work was supported by the Microsoft Jim Gray Systems Lab, 
the National Science Foundation and the Office of Naval Research.
*/
#ifndef SUBFST_H
#define SUBFST_H
//#include "PathEnumerator.h"
#include "PathIterator.h"

//Assuming the maxpathlen in the fst doesnt exceed this
#define INFIN 1e6 

int getNumNodesFst(StdVectorFst *ifst);
int getFinalStateFst(StdVectorFst *ifst);

void addEpsFst(StdVectorFst* ifst);
StdVectorFst projectSubFst_edges(VectorFst<StdArc> *fst, int numnodes, int src_state, int sink_state, int* statepr, set < pair <int, int> > *edges);
void floydstuff(VectorFst<StdArc> *fst, int* nodedismin);

void fsttombin(StdVectorFst* fst, ostream &off);
void mbintofst(StdVectorFst* fst, istream &iff);
void mbintofst(StdVectorFst *fst, char* buffer);

StdVectorFst augmentFst(StdVectorFst* ifst);
vector<double> dynReachProbs (StdVectorFst *ifst);

void getQueryMatrix(StdVectorFst* query, int* dfaquery);

void constructIterator (PathIterator* incrementalN, StdVectorFst* resfst);

#endif
